/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.wrapper;

import org.springblade.community.entity.Agency;
import org.springblade.community.entity.Residential;
import org.springblade.community.feign.IAgencyClient;
import org.springblade.community.feign.IResidentialClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.estate.entity.Car;
import org.springblade.estate.vo.CarVO;
import java.util.Objects;

/**
 * 车辆信息包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-03-30
 */
public class CarWrapper extends BaseEntityWrapper<Car, CarVO>  {

	private static IAgencyClient agencyClient;
	private static IResidentialClient residentialClient;

	static {
		agencyClient = SpringUtil.getBean(IAgencyClient.class);
		residentialClient = SpringUtil.getBean(IResidentialClient.class);
	}

	public static CarWrapper build() {
		return new CarWrapper();
 	}

	@Override
	public CarVO entityVO(Car car) {
		CarVO carVO = Objects.requireNonNull(BeanUtil.copy(car, CarVO.class));
		Agency agency = agencyClient.getById(car.getAgencyId());
		if (agency != null){
			carVO.setAgencyName(agency.getName());
		}
		Residential residential = residentialClient.getById(car.getResidentialId());
		if (residential != null){
			carVO.setResidentialName(residential.getName());
		}
		//User createUser = UserCache.getUser(car.getCreateUser());
		//User updateUser = UserCache.getUser(car.getUpdateUser());
		//carVO.setCreateUserName(createUser.getName());
		//carVO.setUpdateUserName(updateUser.getName());

		return carVO;
	}

}
